﻿<%@ Page Language="C#" AutoEventWireup="true"  %>
<% 
	/// *************************************
	/// http://localhost:62545
	/// *************************************

    string Clientid = ConfigurationManager.AppSettings["APPDATA_1_client_id"];
    string ClientSecret = ConfigurationManager.AppSettings["APPDATA_1_client_secret"];
    string my_url_redirect = ConfigurationManager.AppSettings["APPDATA_1_redirect_uri"];

	string uri_redirect = "http://localhost:62545/Authorize.aspx";
	string uri_token = "http://localhost:62545/GetToken.aspx";
	string uri_data =  "http://localhost:62545/UserInfo.aspx";
	
	if (Request["error"] != null)
	{
		Response.Write("error:" + Request["error"]);
		Response.Write("error_description:" + Request["error_description"]);
	}
	else if (Request["code"] == null) //*******************************    STEP 1
	{
        string redirUrl = uri_redirect + "?redirect_uri=" + my_url_redirect + "&response_type=code&client_id=" + Clientid;
		Response.Redirect(redirUrl);
	}
    else //*******************************    STEP 2
	{
		System.Net.HttpWebRequest req = (System.Net.HttpWebRequest)System.Net.WebRequest.Create(uri_token);

		string parameters = "code="
							+ Request["code"]
							+ "&client_id="
							+ Clientid
							+ "&client_secret="
							+ ClientSecret
							+ "&redirect_uri="
                            + my_url_redirect
							+ "&grant_type=authorization_code";

		req.ContentType = "application/x-www-form-urlencoded";
		req.Method = "POST";
		byte[] bytes = Encoding.ASCII.GetBytes(parameters);

		System.IO.Stream os = null;
		try
		{ // send the Post
			req.ContentLength = bytes.Length;   //Count bytes to send
			os = req.GetRequestStream();
			os.Write(bytes, 0, bytes.Length);         //Send it
		}
		catch (System.Net.WebException e)
		{
			Response.Write("error:" + e.Message);
			return;
		}
		finally
		{
			if (os != null)
			{
				os.Close();
			}
		}
		string response = "";
		try
		{ // get the response
			System.Net.WebResponse webResponse = req.GetResponse();
			System.IO.Stream stream = webResponse.GetResponseStream();
			System.IO.StreamReader reader = new System.IO.StreamReader(stream);
			response = reader.ReadToEnd();

		}
		catch (System.Net.WebException e)
		{
			Response.Write("error:" + e.Message);
			return;
		}
		Newtonsoft.Json.Linq.JObject o = Newtonsoft.Json.Linq.JObject.Parse(response);
		string access_token = o["access_token"].ToString();


		System.Net.HttpWebRequest req2 = (System.Net.HttpWebRequest)System.Net.WebRequest.Create(
				uri_data+"?oauth_token="
				+ access_token);
		req2.Method = "GET";
		System.Net.HttpWebResponse result2 = (System.Net.HttpWebResponse)req2.GetResponse();
		using (System.IO.Stream data2 = result2.GetResponseStream())
		{
			string text2 = new System.IO.StreamReader(data2).ReadToEnd();
			Newtonsoft.Json.Linq.JObject o2 = Newtonsoft.Json.Linq.JObject.Parse(text2);
			Session.Clear();
			Session["name"] = o2["name"];
				
			Response.Write("authentication succeed: "+text2);
		}
	}
%>